#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cconfig.h"

int
main ( int argc, char* argv[] )
{
	t_config* MyConfig;
	int I;
	int Len;
	char* psz_Str;
	char* psz_Server;
	char  sz_Buffer [512];

	if (argc > 1)
		CfgReadConfig (&MyConfig, argv [1]);
	else
		CfgReadConfig (&MyConfig, "example.conf");

	printf ("\n########## - 1 - ###########\n\n");
//	CfgSetStart (MyConfig);
//	CfgDump (1, MyConfig);
//	return (0);
        CfgSetSeperator (MyConfig, ';');
	CfgSetStart (MyConfig);
//	Len = CfgSetToVariable (MyConfig, "PORTS;PORT_161;IP");
//	printf ("found: %u\n", Len);
//	psz_Str = CfgGetVarValue (MyConfig);
	for (I = 1; I < 165; I++)
	{
		sprintf (sz_Buffer, "PORTS;PORT_%u;IP", I);
		psz_Str = CfgGetVarValueOf (MyConfig, sz_Buffer);
		if (psz_Str)
			printf ("S='%s'\n", psz_Str);
		else	printf ("%u not found!\n", I);
	}
	CfgFreeConfig (MyConfig);
	return (0);
	/*
         *      the standard seperator is a '.' which conflicts
         *      with hostnames. so we explicitly choose another
         *      seperator here.
         */
        CfgSetSeperator (MyConfig, ';');
	/*
	 * read our port
	 */
	psz_Str = CfgGetVarValueOf (MyConfig, "port");
        if (psz_Str != 0)
        {
                printf ("port: %u\n", atoi (psz_Str));
	}
	else	printf ("no port!\n");
	/*
	 * read our secret
	 */
	psz_Str = CfgGetVarValueOf (MyConfig, "secret");
        if (psz_Str != 0)
        {
                printf ("secret: %s\n", psz_Str);
	}
	else	printf ("no secret!\n");
	/*
	 * now go for our list of servers
	 */
	if (CfgSetToSection (MyConfig, "servers") == 0)
        {
                printf ("no 'servers'-section in config!\n");
                return (1);
        }
	psz_Str = CfgGetVarName (MyConfig);
        while (psz_Str != 0)
        {
		printf ("got server '%s'\n", psz_Str);
		Len = strlen (psz_Str);
                psz_Server = (char*) malloc (Len+1);
                strncpy (psz_Server, psz_Str, Len+1);
		CfgStore (MyConfig);	/* store current position */
		/*
		 * now go for server config 
		 */
		if (CfgSetToSection(MyConfig, psz_Server) == 0)
                {
			printf ("no config for '%s'\n", psz_Server);
			return (1);
		}
		/* build the complete path to 'server'-port variable */
		sprintf (sz_Buffer, "%s;port", psz_Server);
		psz_Str = CfgGetVarValueOf (MyConfig, sz_Buffer);
		if (psz_Str != 0)
		{
			printf ("port for server %s is %s\n",
				psz_Server, psz_Str);
		}
		/* build the complete path to 'server'-secret variable */
		sprintf (sz_Buffer, "%s;secret", psz_Server);
		psz_Str = CfgGetVarValueOf (MyConfig, sz_Buffer);
		if (psz_Str != 0)
		{
			printf ("secret for server %s is %s\n",
				psz_Server, psz_Str);
		}
		CfgRestore (MyConfig); /* and back to server-section */
		psz_Str = CfgNextVariable (MyConfig);
	}
	CfgFreeConfig (MyConfig);
	return (0);
}
