#include <stdio.h>
#include <stdlib.h>
#include "cfgstack.h"

int
main ()
{
	int*		Current;
	int		I;
	t_CfgStack*	Stack;

	Stack = CfgStack_Create ();
	printf ("pushing...\n");
	for (I=0; I<10; I++)
	{
		Current = (int*) malloc (sizeof(int));
		*Current = I;
		printf ("push: %d\n", *Current);
		CfgStack_Push (Stack, Current);
	}
	printf ("pushed, now popping...\n");
	while (!CfgStack_Empty (Stack))
	{
		Current = ((int*) CfgStack_Pop (Stack));
		if (Current == 0)
			printf ("Content ist 0!\n");
		else	printf ("Pop: %d\n", *Current);
		free (Current);
	}
	CfgStack_Destroy (Stack);
	return (0);
}
