/*	This file is part of cfgd
**
**	Copyright 2002 Oliver Schroeder
**	
**	Permission to use,  copy, modify, and distribute this
**	software  and its  documentation  for any purpose and
**	without any fee is  hereby granted, provided that the
**	above  copyright notice  and  this  permission notice
**	appear in  all copies of the  software and derivative
**	works or modified versions thereof, and that both the
**	copyright notice and  this permission  and disclaimer
**	notice appear in supporting documentation.
**	
**	This software is provided "as is" WITHOUT ANY WARRANTY.
**	
**	Oliver Schroeder <post@o-schroeder.de>
*/

#include <cconfig.h>
#include "clist.h"

/*
**
**	global variables
**
*/
int	g_n_ExternalListenerPort	= 0;
char*	g_psz_LocalListenerPort		= 0;
char*	g_psz_ConfigPathPrefix		= 0;
char*	g_psz_MyConfigFile		= "/etc/cfgd.conf";

/*
**
**	main-routine
**
*/
int main
	(
	int	argc,
	char*	argv []
	)
{
	ParseParams (argc, argv);
	ReadConfig (g_psz_MyConfigFile);
}
